diff bochs-2.1.1/asbestos.build bochs-2.1.1.fixed/asbestos.build
--- bochs-2.1.1/asbestos.build	Wed Dec 31 19:00:00 1969
+++ bochs-2.1.1.fixed/asbestos.build	Mon Aug 23 23:25:39 2004
@@ -0,0 +1,24 @@
+#!/bin/sh
+
+ARGS=""
+ARGS="$ARGS --with-nogui"
+ARGS="$ARGS --with-x11"
+ARGS="$ARGS --enable-iodebug"
+ARGS="$ARGS --enable-ne2000"
+ARGS="$ARGS --disable-reset-on-triple-fault"
+
+set -x
+
+if test ! -d =build; then
+	mkdir =build
+	(cd =build && ../configure $ARGS --enable-debugger --enable-x86-debugger --enable-disasm "$@")
+fi
+set -e
+(cd =build && make)
+set +e
+
+if test ! -d =build.kgdb; then
+	mkdir =build.kgdb
+	(cd =build.kgdb && ../configure $ARGS --enable-gdb-stub "$@")
+fi
+(cd =build.kgdb && make)
diff bochs-2.1.1/asbestos.install bochs-2.1.1.fixed/asbestos.install
--- bochs-2.1.1/asbestos.install	Wed Dec 31 19:00:00 1969
+++ bochs-2.1.1.fixed/asbestos.install	Mon Aug 23 23:25:39 2004
@@ -0,0 +1,7 @@
+#!/bin/sh
+
+(cd =build && make install)
+target="`which bochs`"
+set -x
+test -f "$target" && cp =build.kgdb/bochs $target-kgdb
+
diff bochs-2.1.1/bx_debug/dbg_main.cc bochs-2.1.1.fixed/bx_debug/dbg_main.cc
--- bochs-2.1.1/bx_debug/dbg_main.cc	Wed Feb 11 17:28:51 2004
+++ bochs-2.1.1.fixed/bx_debug/dbg_main.cc	Mon Aug 23 23:25:39 2004
@@ -191,7 +191,6 @@
 
 static void bx_unnest_infile(void);
 static void bx_get_command(void);
-static void bx_dbg_print_guard_results();
 static void bx_dbg_breakpoint_changed(void);
 
 bx_dbg_callback_t bx_dbg_callback[BX_NUM_SIMULATORS];
@@ -1872,7 +1871,7 @@
       // set stop flag if a guard found other than icount or halted
       unsigned long found = BX_CPU(cpu)->guard_found.guard_found;
       stop_reason_t reason = (stop_reason_t) BX_CPU(cpu)->stop_reason;
-      if (found & BX_DBG_GUARD_ICOUNT) {
+      if (found == BX_DBG_GUARD_ICOUNT) {
         // I expected this guard, don't stop
       } else if (found!=0) {
         stop = 1;
diff bochs-2.1.1/bx_debug/debug.h bochs-2.1.1.fixed/bx_debug/debug.h
--- bochs-2.1.1/bx_debug/debug.h	Wed Feb 11 17:28:51 2004
+++ bochs-2.1.1.fixed/bx_debug/debug.h	Mon Aug 23 23:25:39 2004
@@ -112,6 +112,7 @@
 void bx_dbg_sync_cpu(bx_bool set);
 void bx_dbg_fast_forward(Bit32u num);
 void bx_dbg_info_address(Bit32u seg_reg_num, Bit32u offset);
+void bx_dbg_print_guard_results(void);
 #define MAX_CONCURRENT_BPS 5
 extern int timebp_timer;
 extern Bit64u timebp_queue[MAX_CONCURRENT_BPS];
@@ -192,7 +193,9 @@
 extern Bit32u read_watchpoint[MAX_READ_WATCHPOINTS];
 
 typedef enum {
-      STOP_NO_REASON = 0, STOP_TIME_BREAK_POINT, STOP_READ_WATCH_POINT, STOP_WRITE_WATCH_POINT, STOP_MAGIC_BREAK_POINT, UNUSED_STOP_TRACE, STOP_MODE_BREAK_POINT, STOP_CPU_HALTED
+      STOP_NO_REASON = 0, STOP_TIME_BREAK_POINT, STOP_READ_WATCH_POINT,
+      STOP_WRITE_WATCH_POINT, STOP_MAGIC_BREAK_POINT, UNUSED_STOP_TRACE,
+      STOP_MODE_BREAK_POINT, STOP_CPU_HALTED, STOP_CPU_PANIC
 } stop_reason_t;
 
 typedef enum {
diff bochs-2.1.1/configure bochs-2.1.1.fixed/configure
--- bochs-2.1.1/configure.in	Wed Feb 11 17:28:40 2004
+++ bochs-2.1.1.fixed/configure.in	Mon Aug 23 23:25:39 2004
@@ -744,14 +744,26 @@
         AC_DEFINE(HAVE_ETHERTAP, 1)
       fi
 
+      AC_CHECK_HEADER(net/if_tun.h, [
+	  use_tuntap=yes
+	  ], [],
+	  [
+	  #include <sys/types.h>
+	  #include <sys/socket.h>
+	  #include <net/if.h>
+	])
       AC_CHECK_HEADER(linux/if_tun.h, [
-          NETLOW_OBJS="$NETLOW_OBJS eth_tuntap.o"
-          AC_DEFINE(HAVE_TUNTAP, 1)
-        ], [], 
-        [
-    	  #include <asm/types.h>
+	  use_tuntap=yes
+	  ], [],
+	  [
+	  #include <asm/types.h>
 	  #include <sys/socket.h>
-        ])
+	])
+      if test "$use_tuntap" = yes; then
+	NETLOW_OBJS="$NETLOW_OBJS eth_tuntap.o"
+	AC_DEFINE(HAVE_TUNTAP, 1)
+      fi
+
       ;;
     esac
     networking=yes
diff bochs-2.1.1/cpu/cpu.cc bochs-2.1.1.fixed/cpu/cpu.cc
--- bochs-2.1.1/cpu/cpu.cc	Wed Feb 11 17:28:51 2004
+++ bochs-2.1.1.fixed/cpu/cpu.cc	Mon Aug 23 23:25:39 2004
@@ -127,6 +127,11 @@
     // only from exception function can we get here ...
     BX_INSTR_NEW_INSTRUCTION(BX_CPU_ID);
   }
+#elif BX_GDBSTUB
+  if (setjmp( BX_CPU_THIS_PTR jmp_buf_env ))
+  {
+    return;
+  }
 #else
   (void) setjmp( BX_CPU_THIS_PTR jmp_buf_env );
 #endif
@@ -136,6 +141,7 @@
   // the debugger may request that control is returned to it so that
   // the situation may be examined.
   if (bx_guard.special_unwind_stack) {
+printf("CPU_LOOP %d\n", bx_guard.special_unwind_stack);
     return;
     }
 #endif
diff bochs-2.1.1/cpu/cpu.h bochs-2.1.1.fixed/cpu/cpu.h
--- bochs-2.1.1/cpu/cpu.h	Wed Feb 11 17:28:51 2004
+++ bochs-2.1.1.fixed/cpu/cpu.h	Mon Aug 23 23:25:39 2004
@@ -1380,6 +1380,10 @@
   bx_guard_found_t guard_found;
 #endif
 
+#if BX_GDBSTUB
+  Bit8u ispanic;
+#endif
+
 #if BX_SUPPORT_X86_64
 #define TLB_GENERATION_MAX (BX_TLB_SIZE-1)
 #endif
diff bochs-2.1.1/gdbstub.cc bochs-2.1.1.fixed/gdbstub.cc
--- bochs-2.1.1/gdbstub.cc	Wed Feb 11 17:28:41 2004
+++ bochs-2.1.1.fixed/gdbstub.cc	Mon Aug 23 23:25:39 2004
@@ -367,7 +367,13 @@
                    }
                  
                  stub_trace_flag = 0;
+		 bx_cpu.ispanic = 0;
                  bx_cpu.cpu_loop(-1);              
+                 if (bx_cpu.ispanic)
+		   {
+		      last_stop_reason = GDBSTUB_EXECUTION_BREAKPOINT;
+		   }
+ 
                  DEV_vga_refresh();
                  
                  if (buffer[1] != 0)
diff bochs-2.1.1/gui/textconfig.cc bochs-2.1.1.fixed/gui/textconfig.cc
--- bochs-2.1.1/gui/textconfig.cc	Wed Feb 11 17:28:52 2004
+++ bochs-2.1.1.fixed/gui/textconfig.cc	Mon Aug 23 23:25:39 2004
@@ -623,7 +623,7 @@
 }
 
 char *log_action_ask_choices[] = { "cont", "alwayscont", "die", "abort", "debug" };
-int log_action_n_choices = 4 + (BX_DEBUGGER?1:0);
+int log_action_n_choices = 4 + (BX_DEBUGGER||BX_GDBSTUB?1:0);
 
 BxEvent *
 config_interface_notify_callback (void *unused, BxEvent *event)
@@ -680,6 +680,10 @@
 #if BX_DEBUGGER
       fprintf (stderr, "  debug      - continue and return to bochs debugger\n");
 #endif
+#if BX_GDBSTUB
+      fprintf (stderr, "  debug      - hand control to gdb\n");
+#endif
+
       int choice;
 ask:
       if (ask_menu ("Choose one of the actions above: [%s] ", 
diff bochs-2.1.1/iodev/eth_tap.cc bochs-2.1.1.fixed/iodev/eth_tap.cc
--- bochs-2.1.1/iodev/eth_tap.cc	Thu Oct  2 07:33:41 2003
+++ bochs-2.1.1.fixed/iodev/eth_tap.cc	Mon Aug 23 23:25:39 2004
@@ -100,7 +100,7 @@
 #include <sys/socket.h>
 #include <sys/uio.h>
 #include <sys/wait.h>
-#if defined(__FreeBSD__) || defined(__APPLE__)  // Should be fixed for other *BSD
+#if defined (__OpenBSD__) || defined(__FreeBSD__) || defined(__APPLE__)  // Should be fixed for other *BSD
 #include <net/if.h>
 #else
 #include <asm/types.h>
@@ -269,7 +269,7 @@
   Bit8u txbuf[BX_PACKET_BUFSIZ];
   txbuf[0] = 0;
   txbuf[1] = 0;
-#if defined(__FreeBSD__) || defined(__APPLE__)  // Should be fixed for other *BSD
+#if defined (__OpenBSD__) || defined(__FreeBSD__) || defined(__APPLE__)  // Should be fixed for other *BSD
   memcpy (txbuf, buf, io_len);
   unsigned int size = write (fd, txbuf, io_len);
   if (size != io_len) {
@@ -318,7 +318,7 @@
   nbytes = read (fd, buf, sizeof(buf));
 
   // hack: discard first two bytes
-#if defined(__FreeBSD__) || defined(__APPLE__)  // Should be fixed for other *BSD
+#if defined (__OpenBSD__) || defined(__FreeBSD__) || defined(__APPLE__)  // Should be fixed for other *BSD
   rxbuf = buf;
 #else
   rxbuf = buf+2;
diff bochs-2.1.1/iodev/eth_tuntap.cc bochs-2.1.1.fixed/iodev/eth_tuntap.cc
--- bochs-2.1.1/iodev/eth_tuntap.cc	Wed Feb 11 17:28:53 2004
+++ bochs-2.1.1.fixed/iodev/eth_tuntap.cc	Mon Aug 23 23:27:01 2004
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////////
-// $Id: eth_tuntap.cc,v 1.9 2003/04/26 14:48:45 cbothamy Exp $
+// $Id: eth_tuntap.cc,v 1.2 2003/10/02 06:25:56 rsc Exp $
 /////////////////////////////////////////////////////////////////////////
 //
 //  Copyright (C) 2001  MandrakeSoft S.A.
@@ -97,13 +97,25 @@
 #include <sys/poll.h>
 #include <sys/time.h>
 #include <sys/resource.h>
+#ifdef __linux__
 #include <asm/types.h>
+#else
+#include <sys/types.h>
+#endif
 #include <sys/socket.h>
 #include <sys/uio.h>
 #include <sys/wait.h>
+#ifdef __linux__
 #include <linux/netlink.h>
 #include <linux/if.h>
 #include <linux/if_tun.h>
+#elif defined (__OpenBSD__)
+#include <net/if.h>
+#include <net/if_tun.h>
+#else
+#include <net/if.h>
+#include <net/if_tap.h>
+#endif
 #include <assert.h>
 #include <fcntl.h>
 #include <errno.h>
@@ -159,10 +171,11 @@
 				       void *rxarg)
 {
   int flags;
+
+#ifdef NEVERDEF
   if (strncmp (netif, "tun", 3) != 0) {
     BX_PANIC (("eth_tuntap: interface name (%s) must be tun", netif));
   }
-#ifdef NEVERDEF
   char filename[BX_PATHNAME_LEN];
   sprintf (filename, "/dev/net/%s", netif);
 
@@ -373,9 +386,10 @@
       struct ifreq ifr;
       int fd, err;
 
-      if( (fd = open("/dev/net/tun", O_RDWR)) < 0 )
+      if( (fd = open(dev, O_RDWR)) < 0 )
          return -1;
 
+#ifdef __linux__
       memset(&ifr, 0, sizeof(ifr));
 
       /* Flags: IFF_TUN   - TUN device (no Ethernet headers) 
@@ -394,6 +408,7 @@
 
       //strcpy(dev, ifr.ifr_name);
       ioctl( fd, TUNSETNOCSUM, 1 );
+#endif
 
       return fd;
   }              
diff bochs-2.1.1/logio.cc bochs-2.1.1.fixed/logio.cc
--- bochs-2.1.1/logio.cc	Wed Feb 11 17:28:41 2004
+++ bochs-2.1.1.fixed/logio.cc	Mon Aug 23 23:25:39 2004
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////////
-// $Id: logio.cc,v 1.42 2003/08/24 10:30:07 cbothamy Exp $
+// $Id: logio.cc,v 1.2 2003/10/06 04:03:36 rsc Exp $
 /////////////////////////////////////////////////////////////////////////
 //
 //  Copyright (C) 2001  MandrakeSoft S.A.
@@ -514,6 +514,24 @@
       // instruction, it should notice the user interrupt and return to
       // the debugger.
       bx_guard.interrupt_requested = 1;
+
+      // actually, if this is a panic, it's very likely the caller will
+      // not be able to cope gracefully if we return and try to keep
+      // executing.  so longjmp back to the cpu loop immediately.
+      if (level == LOGLEV_PANIC) {
+	BX_CPU_THIS_PTR stop_reason = STOP_CPU_PANIC;
+        bx_guard.special_unwind_stack = 1;
+        in_ask_already = 0;
+        longjmp(BX_CPU_THIS_PTR jmp_buf_env, 1); // go back to main decode loop
+      }
+      break;
+#endif
+#if BX_GDBSTUB
+    case BX_LOG_ASK_CHOICE_ENTER_DEBUG:
+      // user chose debugger (we're using gdb)
+      in_ask_already = 0;
+      BX_CPU_THIS_PTR ispanic = 1;
+      longjmp(BX_CPU_THIS_PTR jmp_buf_env, 1); // go back to main decode loop
       break;
 #endif
     default:
